package com.sogou.shortvideo

import android.app.Activity
import io.flutter.plugin.common.PluginRegistry

class CustomPluginRegistrant {

    companion object{
        fun registerWith(registry: PluginRegistry, activity: Activity) {
            if (alreadyRegisteredWith(registry)) {
                return
            }

            VideoPlayerPlugin.register(registry, SgExoPlayerPlugin())
            OperationPlugin.register(registry, OperationPluginImpl(activity))
        }

        private fun alreadyRegisteredWith(registry: PluginRegistry): Boolean {
            val key = CustomPluginRegistrant::class.java.canonicalName
            if (registry.hasPlugin(key)) {
                return true
            }
            registry.registrarFor(key)
            return false
        }

    }
}