package com.sogou.shortvideo

import android.os.Environment
import com.google.android.exoplayer2.upstream.cache.NoOpCacheEvictor
import com.google.android.exoplayer2.upstream.cache.SimpleCache
import java.io.File

class ExoVideoCache private constructor(){

    companion object{

        private val cacheFile = File(Environment.getExternalStorageDirectory(), "SogouExplorer/short_video")
        
        private var instance: SimpleCache? = null
            get() {
                if (field == null){
                    field = SimpleCache(createCacheFile(), NoOpCacheEvictor())
                }
                return field
            }

        @Synchronized
        fun get(): SimpleCache{
            return instance!!
        }

        private fun createCacheFile(): File? {
            val file = cacheFile
            //判断文件目录是否存在
            if (!file.exists()) {
                file.mkdirs()
            }
            return file
        }

        fun deleteCacheFile(){
            deleteFile(cacheFile)
        }

        private fun deleteFile(f: File): Boolean {
            if (!f.exists()) {
                return true
            }
            if (!f.isDirectory) {
                return f.delete()
            }
            val subFiles = f.listFiles()
            if (subFiles != null) {
                for (file in subFiles) {
                    deleteFile(file)
                }
            }
            return f.delete()
        }
    }
}