package com.sogou.shortvideo

import android.annotation.SuppressLint
import android.content.Context
import android.net.ConnectivityManager
import android.net.NetworkInfo
import android.os.Build
import android.provider.Settings
import android.telephony.TelephonyManager
import android.text.TextUtils
import java.net.URLEncoder

object Utils {

    @SuppressLint("MissingPermission")
    fun getDeviceIMEI(): String {
        try {
            val telephonyManager = MyApp.instance!!.getSystemService(Context.TELEPHONY_SERVICE) as TelephonyManager
            return if (TextUtils.isEmpty(telephonyManager.deviceId)) {
                ""
            } else telephonyManager.deviceId
        } catch (e: Exception) {
        }

        return "866963023483110"
    }

    @SuppressLint("HardwareIds")
    fun getAndroidID(): String {
        var context = MyApp.instance!!

        return "" + Settings.Secure.getString(context.contentResolver,
                    Settings.Secure.ANDROID_ID)

        return ""
    }

    fun getVersionName(): String {
        var context = MyApp.instance!!
        try {
            val packageManager = context.packageManager
            val packInfo = packageManager.getPackageInfo(context.packageName, 0)
            return packInfo.versionName
        } catch (e: Exception) {
        }

        return "0"
    }


    /**
     * 获取当前网络状态
     * @return 移动只返回4G，WiFi返回wifi
     */
    fun checkNetwork() : String{
        try {
            val manager = MyApp.instance!!
                    .getSystemService(Context.CONNECTIVITY_SERVICE) as ConnectivityManager
            val wifi = manager.getNetworkInfo(ConnectivityManager.TYPE_WIFI)
                    .state
            if (wifi == NetworkInfo.State.CONNECTED) {
                return "wifi"
            }
            val mobile = manager.getNetworkInfo(ConnectivityManager.TYPE_MOBILE)
                    .state
            if (mobile == NetworkInfo.State.CONNECTED) {
                return "4G"
            }
        } catch (e: Exception) {
        }

        return "unknown"
    }

    fun getHRVContent(): String {
        var encode = "utf-8"
//        val uuid = getAndroidID()
        val uuid = "ffffffff-8687-d4c6-aa2b-e33c2fea54f3"
        val chanNum = "0000"
        val verName = getVersionName()
        val hardwareVer = Build.MODEL
        val systemVer = "ANDROID" + Build.VERSION.RELEASE
        val sb = StringBuilder()
        try {
            sb.append("&h=").append(URLEncoder.encode(uuid, encode))
                    .append("&r=").append(URLEncoder.encode(chanNum, encode))
                    .append("&v=").append(URLEncoder.encode(verName, encode))
                    .append("&hv=")
                    .append(URLEncoder.encode(hardwareVer, encode))
                    .append("&pv=")
                    .append(URLEncoder.encode(systemVer, encode))
        } catch (e: Exception) {

        }

        return sb.toString()
    }

    fun getHRV(): Map<String, Any>{
        var encode = "utf-8"
//        val uuid = getAndroidID()
        val uuid = "ffffffff-8687-d4c6-aa2b-e33c2fea54f3"
        val chanNum = "0000"
        val verName = getVersionName()
        val hardwareVer = Build.MODEL
        val systemVer = "ANDROID" + Build.VERSION.RELEASE
        
        var map : HashMap<String, Any>  = HashMap()
        map["h"] = URLEncoder.encode(uuid, encode)
        map["r"] = URLEncoder.encode(chanNum, encode)
        map["v"] = URLEncoder.encode(verName, encode)
        map["hv"] = URLEncoder.encode(hardwareVer, encode)
        map["pv"] = URLEncoder.encode(systemVer, encode)
        
        return map
    }

}
