package com.sogou.shortvideo

import android.net.Uri
import android.os.Bundle
import android.support.v7.app.AppCompatActivity
import android.view.View
import com.google.gson.Gson
import com.sogou.shortvideo.videolist.VideoBean
import io.flutter.facade.Flutter
import io.flutter.plugins.GeneratedPluginRegistrant
import io.flutter.view.FlutterView
import kotlinx.android.synthetic.main.activity_video_page.*

class VideoPageActivity : AppCompatActivity() {

    private lateinit var flutterview: FlutterView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.activity_video_page)

        var video : VideoBean = intent.getSerializableExtra("video") as VideoBean

        var videoJson = Gson().toJson(video)

        var uri: String = "flutter://navigation?video=${Uri.encode(videoJson)}&channel=小视频&orderType=2"

        flutterview = Flutter.createView(this, lifecycle, uri)
        flutterview.addFirstFrameListener { 
            container.visibility = View.VISIBLE
        }
        GeneratedPluginRegistrant.registerWith(flutterview.pluginRegistry)
        CustomPluginRegistrant.registerWith(flutterview.pluginRegistry, this)
        container.addView(flutterview)
    }

    override fun onBackPressed() {
        if (flutterview != null) {
            flutterview.postDelayed({
                flutterview.popRoute()
            }, 150)
        }
        super.onBackPressed()
    }
}