package com.sogou.shortvideo.net

import okhttp3.OkHttpClient
import retrofit2.Retrofit
import retrofit2.converter.gson.GsonConverterFactory
import java.util.concurrent.TimeUnit

object RetrofitEngine {

    private const val READ_TIMEOUT_MS = 30 * 1000L
    private const val CONNECT_TIMEOUT_MS = 10 * 1000L
    private const val WRITE_TIMEOUT_MS = 30 * 1000L
    private val TIMEOUT_UNIT = TimeUnit.MILLISECONDS
    private val retrofit:Retrofit

    init {
        val client = OkHttpClient.Builder()
                .readTimeout(READ_TIMEOUT_MS, TIMEOUT_UNIT)
                .connectTimeout(CONNECT_TIMEOUT_MS, TIMEOUT_UNIT)
                .writeTimeout(WRITE_TIMEOUT_MS, TIMEOUT_UNIT)
                .build()

        retrofit = Retrofit.Builder()
                .baseUrl("https://bazinga.mse.sogou.com")
                .addConverterFactory(GsonConverterFactory.create())
                .client(client)
                .build()
    }

    fun <T> create(services: Class<T>): T {
        return retrofit.create(services)
    }

}

