package com.sogou.shortvideo

import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry

class OperationPlugin : MethodChannel.MethodCallHandler {

    private var registrar: PluginRegistry.Registrar

    private var actionPluginImpl : IOperationPlugin

    constructor(registrar: PluginRegistry.Registrar, plugin: IOperationPlugin){
        this.registrar = registrar
        this.actionPluginImpl = plugin
    }

    companion object{
        
        private const val PLUGIN_VIDEO_PLAYER: String = "com.sogou.flutter.plugin/sg_action"

        fun register(pluginRegistry : PluginRegistry, plugin: IOperationPlugin){
            registerWith(pluginRegistry.registrarFor(PLUGIN_VIDEO_PLAYER), plugin)
        }

        fun registerWith(registrar: PluginRegistry.Registrar, plugin: IOperationPlugin){
            val channel = MethodChannel(registrar.messenger(), PLUGIN_VIDEO_PLAYER)
            val instances = OperationPlugin(registrar, plugin)
            channel.setMethodCallHandler(instances)
            registrar.addViewDestroyListener {
                false // We are not interested in assuming ownership of the NativeView.
            }
        }
    }


    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {

        if (actionPluginImpl != null){
            actionPluginImpl.dispatchCall(registrar, call, result)
        }
    }
}