//
//  DataPageViewController.m
//  Runner
//
//  Created by qingtaogao on 2019/9/25.
//  Copyright © 2019 The Chromium Authors. All rights reserved.
//

#import "DataPageViewController.h"
#import <Flutter/Flutter.h>
#import "GeneratedPluginRegistrant.h"
#import "FlutterShortVideoMethodCall.h"
#import "VideoPlayerPlugin.h"

@interface DataPageViewController ()
@property (weak, nonatomic) IBOutlet UIButton *openButton;

@end

@implementation DataPageViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}
- (IBAction)clickOpen:(id)sender {
    [self showFLutter];
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/
+ (id)getJsonDataWithJsonString:(NSString *)jsonString {
    if (jsonString == nil) {
        return nil;
    }
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers
                                                          error:&err];
    if(err) {
        NSLog(@"json解析失败：%@",err);
        return nil;
    }
    return dic;
}
//打开小视频播放界面,涉及初试数据需要把数据转换为flutter可以接受的数据字符串
+ (NSString *)getEnterFlutterDataFromModel{
    NSString * videoUrl = @"http://resource.yaokan.sogoucdn.com/videodown/5e9f/337/b3c3713dbe32dd0cdd7d55acc9066903.mp4";
    NSString * url = @"https://bazinga.mse.sogou.com/zixun/index.html?sys=ios&h=FB764AA2-7E3E-4DB9-BA6D-9CAB309F3D9D&r=0000&imei=46DE8FD0-2036-4809-8974-C4E528B87A78&s=http%253A%2f%2fshida%2esogou%2ecom%2fna%253Fshida%255Ffeed%253D1%2526shida%255Ffeed%255Furl%253Dhttp%25253A%2f%2fresource%2eyaokan%2esogoucdn%2ecom%2fvideodown%2f5e9f%2f493%2f49339ca5bcf3c2beceab3ead39cb26d8%2emp4%2526shida%255Ffeed%255Fdid%253D1992510t1kcwVD&rf=&label=小视频&from=&sourceid=1992510t1kcwVD&dtrans=&dsource=search&topic=大图视频";
    NSString * title = @"鉴赏一下，国之美玉!祝福祖国建国70周年!";
    NSArray * picurls = @[@"http://img01.sogoucdn.com/v2/thumb/crop/xy/ai/w/570/h/750/t/0/retype/q/80/ext/auto?appid=200576&url=http%3A%2F%2Fimg02.sogoucdn.com%2Fapp%2Fa%2F200883%2Fa5dde7e58efbd25ab1abdf6379581d89",@"http://img01.sogoucdn.com/v2/thumb/crop/xy/ai/w/720/h/1280/t/0/retype/q/80/ext/auto?appid=200576&url=http%3A%2F%2Fimg02.sogoucdn.com%2Fapp%2Fa%2F200883%2Fa5dde7e58efbd25ab1abdf6379581d89"];
    NSArray * reason = @[@"不想看:房价",@"不想看:房产",@"内容重复",@"内容低俗",@"广告软文",@"标题夸张",
    @"拉黑作者:浮生苍白如梦"];
    NSArray * tagList = @[];
    NSString * fromIcon = @"http://img02.sogoucdn.com/app/a/100540019/f7225b37d26984b47b266f433251a4e5";
    NSString * from = @"疯人愿";
    NSInteger videoWidth = 576;
    NSInteger videoHeight = 1024;
    NSInteger visit = 41766;
    NSInteger commentCnt = 30;
    NSInteger timeStamps = 1569388149017;
    NSString * newsId = @"1992510t1kcwVD";
    NSString * topic = @"大图视频";
    NSString * videoTime = @"00:09";
    NSInteger showType = 12;
    NSString * key = @"http%3A//shida.sogou.com/na%3Fshida%5Ffeed%3D1%26shida%5Ffeed%5Furl%3Dhttp%253A//resource.yaokan.sogoucdn.com/videodown/5e9f/493/49339ca5bcf3c2beceab3ead39cb26d8.mp4%26shida%5Ffeed%5Fdid%3D1992510t1kcwVD";
    BOOL isSupport = false;
    NSInteger supportNum = 0;
    
    NSMutableDictionary * dataDic = [NSMutableDictionary new];
    [dataDic setObject:videoUrl forKey:@"video_url"];
    [dataDic setObject:url forKey:@"url"];
    [dataDic setObject:title forKey:@"title"];
    [dataDic setObject:picurls forKey:@"picurls"];
    [dataDic setObject:reason forKey:@"reason"];
    [dataDic setObject:tagList forKey:@"tag_list"];
    [dataDic setObject:fromIcon forKey:@"from_icon"];
    [dataDic setObject:from forKey:@"from"];
    [dataDic setObject:@(videoWidth) forKey:@"video_width"];
    [dataDic setObject:@(videoHeight) forKey:@"video_height"];
    [dataDic setObject:@(visit) forKey:@"visit"];
    [dataDic setObject:@(commentCnt) forKey:@"comment_cnt"];
    [dataDic setObject:@(timeStamps) forKey:@"timestampms"];
    [dataDic setObject:newsId forKey:@"newsid"];
    [dataDic setObject:topic forKey:@"topic"];
    [dataDic setObject:videoTime forKey:@"video_time"];
    [dataDic setObject:@(showType) forKey:@"showtype"];
    [dataDic setObject:key forKey:@"key"];
    [dataDic setObject:@(isSupport) forKey:@"is_support"];
    [dataDic setObject:@(supportNum) forKey:@"support_num"];
    
    NSString * jsonStr = [DataPageViewController convertToJSONData:dataDic];
    NSString * nativeToFlutterStr = [NSString stringWithFormat:@"nativetoflt?%@",jsonStr];
    NSLog(@"打开小视频播放传给Flutter传递的数据:%@",nativeToFlutterStr);
    return nativeToFlutterStr;
}
+ (NSString*)convertToJSONData:(id)infoDict
{
    NSError *error;
    NSData *jsonData = [NSJSONSerialization dataWithJSONObject:infoDict
                                                       options:NSJSONWritingPrettyPrinted // Pass 0 if you don't care about the readability of the generated string
                                                         error:&error];
    NSString *jsonString = @"";
    if (! jsonData) {
        NSLog(@"error: %@", error);
    }else {
        jsonString = [[NSString alloc] initWithData:jsonData encoding:NSUTF8StringEncoding];
    }
    jsonString = [jsonString stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];  //去除掉首尾的空白字符和换行字符
    jsonString = [jsonString stringByReplacingOccurrencesOfString:@"\n" withString:@""];
    return jsonString;
}

- (void)showFLutter {
//    FlutterViewController *flutterViewController = [[FlutterViewController alloc] init];
    UIStoryboard * main = [UIStoryboard storyboardWithName:@"Main" bundle:[NSBundle mainBundle]];
    FlutterViewController * flutterViewController = (FlutterViewController *) [main  instantiateViewControllerWithIdentifier:@"FlutterPage"];
    NSString * firstData = [DataPageViewController getEnterFlutterDataFromModel];
    [flutterViewController setInitialRoute:firstData];
    [GeneratedPluginRegistrant registerWithRegistry:flutterViewController];
    [FLTVideoPlayerPlugin registerWithRegistrar:[flutterViewController registrarForPlugin:@"FLTVideoPlayerPlugin"]];
    [FlutterShortVideoMethodCall registerWithRegistrar:[flutterViewController registrarForPlugin:@"FlutterShortVideoMethodCall"]];
    flutterViewController.modalPresentationStyle = UIModalPresentationOverFullScreen;
    [self presentViewController:flutterViewController animated:false completion:nil];
    //pingback
}
@end
