//
//  FlutterShortVideoMethodCall.m
//  SeMob
//
//  Created by qingtaogao on 2019/9/9.
//

#import "FlutterShortVideoMethodCall.h"

@interface FlutterShortVideoMethodCall ()<FlutterStreamHandler>
@property(readonly, nonatomic) NSObject<FlutterTextureRegistry>* registry;
@property(readonly, nonatomic) NSObject<FlutterBinaryMessenger>* messenger;
@property(readonly, nonatomic) NSObject<FlutterPluginRegistrar>* registrar;

@end


@implementation FlutterShortVideoMethodCall

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel =
    [FlutterMethodChannel methodChannelWithName:@"com.sogou.flutter.plugin/sg_action" binaryMessenger:[registrar messenger]];
    FlutterShortVideoMethodCall* instance = [[FlutterShortVideoMethodCall alloc] initWithRegistrar:registrar];
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (instancetype)initWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    self = [super init];
    NSAssert(self, @"super init cannot be nil");
    _registry = [registrar textures];
    _messenger = [registrar messenger];
    _registrar = registrar;
    
//    NSString *channelName = @"com.sogou.flutter.plugin/showtoast";
//    FlutterEventChannel *evenChannal = [FlutterEventChannel eventChannelWithName:channelName binaryMessenger:[registrar messenger]];
//    // 代理FlutterStreamHandler
//    [evenChannal setStreamHandler:self];
    
    return self;
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    NSLog(@"Flutter调用方法=%@,参数=%@,call=%@",call.method,call.arguments,call);
    if ([@"action_pageClose" isEqualToString:call.method]) {//页面返回
        
    }else if ([@"action_feedBack" isEqualToString:call.method]) {//投诉
        
    }else if ([@"action_notLike" isEqualToString:call.method]) {//不喜欢
        
    }else if ([@"action_favorite" isEqualToString:call.method]) {//收藏
        
    }else if ([@"pingbackClickUserHeader" isEqualToString:call.method]) {//点击用户头像
        
    }else if ([@"pingbackClickUserName" isEqualToString:call.method]) {//点击用户昵称
        
    }else if ([@"pingbackClickVideoDesc" isEqualToString:call.method]) {//点击视频描述
        
    }else if ([@"action_writeComments" isEqualToString:call.method]) {//写评论
        
    }else if ([@"action_giveLike" isEqualToString:call.method]) {//点赞按钮
        
    }else if ([@"action_showComments" isEqualToString:call.method]) {//展示评论
        
    }else if ([@"action_share" isEqualToString:call.method]) {//分享
        
    }else if ([@"action_showad_track" isEqualToString:call.method]) {//广告展现回传
        
    }else if ([@"action_openAdDetail" isEqualToString:call.method]) {//查看详情
        
    }else if ([@"action_downloadAdApp" isEqualToString:call.method]) {//立即下载
        
    }else if([@"action_getsysinfo" isEqualToString:call.method]) {
        NSDictionary * dic = [FlutterShortVideoMethodCall getDeviceInfo];
        result(dic);
    }else if([@"action_statistics" isEqualToString:call.method]) {
       //
    }if([@"action_education_show" isEqualToString:call.method]) {//小视频教育页展示了
        NSDictionary * dic = (NSDictionary *) call.arguments;
        if (!dic) {
           return;
        }
    }else if([@"action_stayscreen_light" isEqualToString:call.method]) {//视频播放期间保存屏幕长亮
        NSNumber * param = (NSNumber *) call.arguments;
        if (!param) {
           return;
        }
    }else if ([@"action_when_crash" isEqualToString:call.method]) {//flutter crash 调用
        NSDictionary * dic = (NSDictionary *) call.arguments;
        if (!dic) {
            return;
        }
        NSLog(@"FLuttercrash 日志=%@",dic);
    }
    //%e5%b0%8f%e8%a7%86%e9%a2%91 小视频encode
}

+ (NSDictionary *)getDeviceInfo {
    NSString * pv=@"IOS12.4.1";
    NSString * hv=@"iPhone11%2C6";
    NSString * h=@"FB764AA2-7E3E-4DB9-BA6D-9CAB309F3D9D";
    NSString * mid=@"FDbnSZr0gL%2Fd1mHPQ0fCskV5NBfM5We%2FM1eO1ZRsPU8KO9fg4hD3dhK%2FeQG6T5tb";
    NSString * idfa=@"243C27AC-8486-48B5-9776-19C0B6B7CB59";
    NSString * r=@"0000";
    NSString * img=@"jpg";
    NSString * sys=@"ios";
    NSString * imei=@"46DE8FD0-2036-4809-8974-C4E528B87A78";
    NSString * machineType=@"iPhone11%2C";
    NSString * nt=@"wifi";
    NSString * v=@"5.18.0";
    
    NSDictionary * deiceDic = @{
        @"h":h,
        @"v":v,
        @"r":r,
        @"hv":hv,
        @"pv":pv,
        @"imei":imei,
        @"sys":sys,
        @"img":img,
        @"machineType":machineType,
        @"nt":nt,
        @"mid":mid,
        @"idfa":idfa
    };
    return deiceDic;
}

#pragma mark - <FlutterStreamHandler>
// // 这个onListen是Flutter端开始监听这个channel时的回调，第二个参数 events是用来传数据的载体。
- (FlutterError* _Nullable)onListenWithArguments:(id _Nullable)arguments
                                       eventSink:(FlutterEventSink)events {
    // arguments flutter给native的参数
    // 回调给flutter， 建议使用实例指向，因为该block可以使用多次
    NSLog(@"native调用flutter");
    if (arguments) {
        NSLog(@"数据=%@",arguments);
    }
    if (events) {
        events(@"push传值给flutter的vc");
    }
    return nil;
}

/// flutter不再接收
- (FlutterError* _Nullable)onCancelWithArguments:(id _Nullable)arguments {
    // arguments flutter给native的参数
    NSLog(@"flutter不再接收%@", arguments);
    return nil;
}
@end
