/// 设备信息相关；
/// 避免使用get_version, device_info等三方库，由开发者提供接口获取；
class DeviceInfo {
  static DeviceInfo _globalInfo = null;

  DeviceInfo(this.deviceModel, this.deviceId, this.osName, this.osVersion,
      this.appVersionName, this.appVersionCode, this.appChannel);

  static DeviceInfo get info {
    return _globalInfo;
  }

  static set info(DeviceInfo newInfo) {
    _globalInfo = newInfo;
  }

  /// 设备型号
  final String deviceModel;

  /// 设备ID；此可根据不同平台有所差异（ios/android/web）
  final String deviceId;

  /// 操作系统名称：ios,android,web
  final String osName;

  /// 操作系统版本号
  final String osVersion;

  /// app 版本名称
  final String appVersionName;

  /// app 版本号
  final int appVersionCode;

  /// app 渠道
  final String appChannel;
}
