/// 日志相关；
/// 推荐所有模块均使用此接口打印日志
abstract class ILog {
  static ILog _globalLg = null;

  static ILog get lg {
    return _globalLg;
  }

  static void resetLg(ILog newLg) {
    _globalLg = newLg;
  }

  void i(String message);

  void d(String message);

  void e(String message);

  /// 直接打印 xx 方法被调用
  void invoke([String message]);

  /// 直接打印 xx 方法未实现
  void notImp();
}
