class INetHttp_Response {
  /// Response body. may have been transformed, please refer to [ResponseType].
  List<int> data;

  /// Response headers.
  Map<String, String> headers;

  /// Http status code.
  int statusCode;

  /// We care more about `data` field.
  @override
  String toString() => "[data]=" + data.toString();
}

/// http 请求处理模块
abstract class INetHttp {
  static INetHttp _globalHttp = null;

  static INetHttp get http {
    return _globalHttp;
  }

  static void resetHttp(INetHttp newHttp) {
    _globalHttp = newHttp;
  }

  Future<INetHttp_Response> makeHttpRequest(
      String targetURL, Map<String, dynamic> para, Map<String, dynamic> headers,
      [bool isGet]);

  // 以form形式上传数据
  Future<INetHttp_Response> makeFormRequest(String targetURL,
      Map<String, dynamic> para, Map<String, dynamic> headers);
}
