/// SharedPreferences 接口
/// 实现按 key value 操作
abstract class IStoreSp{
  static IStoreSp _globalSp = null;

  static IStoreSp get sp {
    return _globalSp;
  }

  static void resetSp(IStoreSp newSp) {
     _globalSp = newSp;
  }

  Set<String> getKeys();

//  /// Reads a value of any type from persistent storage.
//  dynamic get(String key);

  /// Reads a value from persistent storage, throwing an exception if it's not a
  /// bool.
  bool getBool(String key);

  /// Reads a value from persistent storage, throwing an exception if it's not
  /// an int.
  int getInt(String key);

  /// Reads a value from persistent storage, throwing an exception if it's not a
  /// double.
  double getDouble(String key);

  /// Reads a value from persistent storage, throwing an exception if it's not a
  /// String.
  String getString(String key);
  /// Saves a boolean [value] to persistent storage in the background.
  ///
  /// If [value] is null, this is equivalent to calling [remove()] on the [key].
  Future<bool> setBool(String key, bool value);

  /// Saves an integer [value] to persistent storage in the background.
  ///
  /// If [value] is null, this is equivalent to calling [remove()] on the [key].
  Future<bool> setInt(String key, int value);

  /// Saves a double [value] to persistent storage in the background.
  ///
  /// Android doesn't support storing doubles, so it will be stored as a float.
  ///
  /// If [value] is null, this is equivalent to calling [remove()] on the [key].
  Future<bool> setDouble(String key, double value) ;

  /// Saves a string [value] to persistent storage in the background.
  ///
  /// If [value] is null, this is equivalent to calling [remove()] on the [key].
  Future<bool> setString(String key, String value);

//  /// Saves a list of strings [value] to persistent storage in the background.
//  ///
//  /// If [value] is null, this is equivalent to calling [remove()] on the [key].
//  Future<bool> setStringList(String key, List<String> value);

  /// Removes an entry from persistent storage.
  Future<bool> remove(String key);

  /// Completes with true once the user preferences for the app has been cleared.
  Future<bool> clear();

}