import 'package:short_video/bean/video_item.dart';
import 'package:short_video/network/i_rsp_base.dart';

/// 视频列表返回数据类型
class RspVideoList extends BaseResponse {
  List<VideoItem> videos;

  @override
  bool initFromJson(Map<String, dynamic> srcJson) {
    var superRes = super.initFromJson(srcJson);
    if (!superRes) {
      return false;
    }
    List jsonList = srcJson['list'];
    videos = List<VideoItem>();
    jsonList.forEach((ele) {
      VideoItem vii = VideoItem();
      if (vii.initFromJson(ele)) {
        if(vii.from != null && vii.from is String){
          //用户头像为空不展示该条数据
          if(vii.from.length >= 0 ) {
            videos.add(vii);
          }
        }
      }
    });
    return true;
  }

  @override
  Map<String, dynamic> toJson() {
    var superRes = super.toJson();
    List jsonList = List<Map>();
    if (videos != null) {
      videos.forEach((ele) {
        var mapRes = ele.toJson();
        jsonList.add(mapRes);
      });
    }

    superRes['list'] = jsonList;

    return superRes;
  }
}
