import 'package:short_video/network/i_json_codec.dart';

class VideoItem extends JsonDecodable with JsonEncodable {
  // 连接地址
  String video_url;
  String url;

  // 视频标题
  String title;

  // 截图
  List<dynamic> picurls;

  //不喜欢原因
  List<dynamic> reason;

  List<dynamic> tag_list;

// 用户头像
  String from_icon;

  //用户昵称
  String from;

  // 视频宽高
  int video_width;
  int video_height;

  //播放量
  int visit;

  //评论数
  int comment_cnt;

  //发布时间 毫秒
  int timestampms;

  String newsid;
  String topic;

  //  视频时长
  String video_time;
  int showtype;

  //数据源地址
  String key;

  //是否点赞
  bool is_support;

  //点赞数
  int support_num;

  /// 广告类型  非下载类广告  有category参数（默认值为-2） 且 adtype=0 ；    下载类广告  有category参数（默认值为-2） 且 adtype=1
  int adtype;

  /// 视频类型 小视频 没有category 参数；    非下载类广告  有category参数
  int category;

  ///
  List<dynamic> trackUrls;//广告展示的时候调用

  ///
  List<dynamic> clickUrls;//广告点击的时候调用 回传

  @override
  bool initFromJson(Map<String, dynamic> srcJson) {
    video_url = srcJson['video_url'];
    showtype = srcJson['showtype'];
    picurls = srcJson['picurls'];
    video_width = srcJson['video_width'];
    video_height = srcJson['video_height'];

    from_icon = srcJson['from_icon'];
    from = srcJson['from'];
    visit = srcJson['visit'];
    support_num = srcJson['support_num'];
    is_support = srcJson['is_support'];
    comment_cnt = srcJson['comment_cnt'];
    key = srcJson['key'];
    title = srcJson['title'];
    timestampms = srcJson['timestampms'];
    reason = srcJson['reason'];
    url = srcJson['url'];
    tag_list = srcJson['tag_list'];
    newsid = srcJson['newsid'];
    topic = srcJson['topic'];
    video_time = srcJson['video_time'];
    adtype = srcJson['adtype'];
    category = srcJson['category'];
    trackUrls = srcJson['trackUrls'];
    clickUrls = srcJson['clickUrls'];
    return true;
  }

  @override
  Map<String, dynamic> toJson() {
    var dataJson = {
      "video_url": video_url,
      "screenshotUrl": picurls,
      "video_width": video_width,
      "video_height": video_height,
    };
    return dataJson;
  }

  @override
  String toString() {
    return 'VideoItem{video_url: $video_url, url: $url, title: $title, picurls: $picurls, reason: $reason, tag_list: $tag_list, from_icon: $from_icon, from: $from, video_width: $video_width, video_height: $video_height, visit: $visit, comment_cnt: $comment_cnt, timestampms: $timestampms, newsid: $newsid, topic: $topic, video_time: $video_time, showtype: $showtype, key: $key, is_support: $is_support, support_num: $support_num}';
  }
}
