import 'dart:async';

import 'package:flutter/material.dart';
import 'package:short_video/base/i_log.dart';
import 'package:short_video/bean/rsp_video_list.dart';
import 'package:short_video/model_main.dart';
import 'package:short_video/network/sg_request.dart';
import 'package:short_video/platform/sg_operation.dart';
import 'package:short_video/widget/common/common_expansion_item.dart';

/// debug button 点击事件
///
class DebugPanelCommon extends CommonExpansionItem {
  bool _isExpaneded;

  @override
  Widget buildExpandedBody(BuildContext context) {
    return new Padding(
      padding: EdgeInsets.all(5),
      child: Column(
        children: <Widget>[
          RaisedButton(
            onPressed: () {
              testServerApi(context);
            },
            child: new Text('Demo Server Api'),
          ),
          RaisedButton(
            onPressed: () {
              callNativeFun(context);
            },
            child: new Text('Call Native Fun'),
          ),
          RaisedButton(
            onPressed: () {
              testNativeCrash(context);
            },
            child: new Text('AAAAA'),
          ),
          RaisedButton(
            onPressed: () {
              testCrash(context);
            },
            child: new Text('Test Dart Crash'),
          ),
        ],
      ),
    );
  }

  @override
  String getHeaderName() {
    // TODO: implement getHeaderName
    return "Common";
  }

  @override
  String getHeaderHint() {
    // TODO: implement getHaderHint
    return "testing";
  }

  @override
  String getHeaderValue() {
    // TODO: implement getHaderValue
    return "Click to debug";
  }

  /// 一直打开
  @override
  bool isExpanded() {
    if (_isExpaneded == null) {
      return false;
    }
    return _isExpaneded;
  }

  @override
  void resetExpanded(bool expaned) {
    // TODO: implement resetExpaned
    _isExpaneded = expaned;
  }

  @override
  void dispose() {
    // TODO: implement dispose
  }

  @override
  void initState() {
    // TODO: implement initState
  }
  void callNativeFun(BuildContext context) async {
    ILog.lg.i("callNativeFun Start ");

    String res = (await SgOperation.manualDebug("123"));

    ILog.lg.i("callNativeFun end ");
//    MainModel.of(context).playerController.debug(1);
  }

  void testServerApi(BuildContext context) async {
    ILog.lg.i("testServerApi");

    ReqGetVideoList videoList = ReqGetVideoList();
    videoList.para1 = "this is string para";
    videoList.para2 = 100;

    RspVideoList rsp = await videoList.doRequest();
    if(rsp.isServerOK()){
      ILog.lg.i("RspVideoList OK:${rsp.videos.length}");
    }else{
      ILog.lg.e("RspVideoList ERROR:${rsp.getErrorMsg()}");
    }
  }


  void testCrash(BuildContext context) {
    ILog.lg.i("testCrash");

    // 1、启动定时产生excatipn
    Timer(Duration(milliseconds: 200), () {
      ILog.lg.i("Timer triggered");

      int a = 100;
      int b = 0 ;
      double c = (a / b) ;
      print("c" + c.toString());

      String nullString;
      var charAT = nullString.substring(0, 100);
      throw new CustomException('This is timer exception');
    });

    // 2.本地直接产生；否则会被gesture捕获
    int a = 100;
    int b = 0 ;
    double c = (a / b) ;
    print("c" + c.toString());

    String nullString;
    var charAT = nullString.substring(0, 100);
    throw new CustomException('This is gen exception');
  }


  void testNativeCrash(BuildContext context) {
    ILog.lg.i("testNativeCrash");
//    PlatformUtil.debugNativeCrash();
//    final crash = List()[25];
//    debugPrint(crash);
//
//    int a = 100;
//    int b = 0;
//    int c = (a/b) as int;
//
//    String nullString;
//    var charAT = nullString.substring(0, 100);
//    print("charAT" + charAT.toLowerCase());
//    print("c" + c.toString());
  }
}

class CustomException implements Exception {
  String cause;
  CustomException(this.cause);
}
