

import 'package:short_video/base/i_log.dart';
import 'package:short_video/network/i_json_codec.dart';

import 'net_const.dart';

/// 后端返回数据格式基类；
class BaseResponse extends JsonDecodable  with JsonEncodable{
  int code;
  String msg;

  /// 解析成功返回true，否则返回false
  @override
  bool initFromJson(Map<String, dynamic> srcJson) {
    if (srcJson == null || srcJson.length < 1) {
      code = NetConst.HTTP_ERROR_WRONG_FORMATION;
      msg = "Can not ResBussBase::initFromJson from null json";
      return false;
    }

    code = NetConst.HTTP_ERROR_SERVER_OK;
    msg = "OK";

    return true;
  }

  /// 用以基类覆盖，判断服务器返回状态是否 OK（业务，跟认证判断是否ok的机制不一样）
  bool isServerOK() {
    return code != null && code == NetConst.HTTP_ERROR_SERVER_OK;
  }

  String getErrorMsg() {
    return msg;
  }

  bool checkJsonKey(Map<String, dynamic> srcJson, String keyName) {
    assert(keyName != null && keyName != "");
    assert(srcJson != null);
    if (!srcJson.containsKey(keyName)) {
      ILog.lg.e("WRONG JSON, No '$keyName'");
      return false;
    } else {
      return true;
    }
  }

  @override
  Map<String, dynamic> toJson() {
    var res = Map<String, dynamic>();
    res['code'] = code;
    res['msg'] = msg;
    return res;
  }
}