import 'package:flutter/services.dart';
import 'package:short_video/base/device_info.dart';
import 'package:short_video/base/i_log.dart';

/// 用以获取设备信息以及app版本信息等
///
class SgPlatformInfo {
  static const _platformFaceAuth =
      const MethodChannel('com.sogou.flutter.plugin/sys_info');

  /// 获取系统信息
  static Future<DeviceInfo> getSysInfo(bool muteMode) async {
    Map<String, dynamic> mapRes;

    try {
      mapRes = await _platformFaceAuth.invokeMethod('getSysInfo');
      assert(mapRes != null);
      return DeviceInfo(
          mapRes['deviceModel'],
          mapRes['deviceId'],
          mapRes['osName'],
          mapRes['osVersion'],
          mapRes['appVersionName'],
          mapRes['appVersionCode'],
          mapRes['appChannel']);
    } on PlatformException catch (e) {
      ILog.lg.e("Invoked platform fun failed: getSysInfo E:" + e.toString());
    }
    return null;
  }
}
