
import 'package:flutter/material.dart';
import 'package:short_video/platform/sg_player.dart';

import 'base/i_log.dart';

class TestScreen extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return _TestScreenState();
  }

}

class _TestScreenState extends State<TestScreen>{
  VideoPlayerController _videoPlayerController;
  String dataSource = "http://sofa.resource.shida.sogoucdn.com/c32965a8-6102-4018-88b0-fe1bf683df6d2_0_0.mp4";
  @override
  void initState() {
    // TODO: implement initState
    super.initState();

    _videoPlayerController =  VideoPlayerController();

    _videoPlayerController.init().then((_) {

      _videoPlayerController.resetDataSource(dataSource,false);

    });

    _videoPlayerController.addListener(_onPlayerStatusChanged);
  }

  void _onPlayerStatusChanged() async {
    ILog.lg.i("_onPlayerStatusChanged:${_videoPlayerController.value.status}");
    if(_videoPlayerController.value.status == PlayerStatus.initialized){
      _videoPlayerController.play();
    }
    setState(() {

    });
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        resizeToAvoidBottomInset: false,
        resizeToAvoidBottomPadding: false,
        body:Center(
          child: AspectRatio(
            aspectRatio: 800 / 600,
            child: VideoPlayer(_videoPlayerController),
          ),
        ));
  }

}