

import 'dart:collection';
import 'dart:io';

import 'package:flutter/foundation.dart';
import 'package:short_video/platform/sg_operation.dart';

class CrashHandler{

  static void captureException({@required dynamic exception, dynamic stackTrace}){

    assert(stackTrace is String || stackTrace is StackTrace);

    StringBuffer trace = new StringBuffer();
    trace.writeln(exception);

    if(stackTrace is StackTrace){
      trace.writeln(stackTrace.toString());
    }else{
      trace.writeln(stackTrace);
    }

    Map<String, dynamic> extra = new HashMap();
    extra["numberOfProcessors"] = Platform.numberOfProcessors;
    extra["localeName"] = Platform.localeName;
    extra["operatingSystem"] = Platform.operatingSystem;
    extra["operatingSystemVersion"] = Platform.operatingSystemVersion;
    extra["resolvedExecutable"] = Platform.resolvedExecutable;
    extra["ScriptUri"] = Platform.script.toString();
    extra["executableArguments"] = Platform.executableArguments;
    extra["packageConfig"] = Platform.packageConfig;
    extra["Dart runtime"] = Platform.version;

    SgOperation.whenCrash(extra.toString(), trace.toString());
  }

}