
import 'package:intl/intl.dart';
import 'package:short_video/base/i_log.dart';
import 'package:short_video/bean/video_item.dart';
import 'package:short_video/platform/sg_operation.dart';
import 'package:short_video/util/constant.dart';

class StatisticsHelper{

  static void shortVideoPlayer(VideoItem video){

    Map<String, dynamic> param = Map();

    param["name"] = Constant.CHANNEL;
    param["url"] = video.video_url??"";
    param["title"] = video.title??"";
    param["newsid"] = video.newsid??"";
    param["news_topic"] = video.topic??"";
    param["time"] = getCurrentTime();
    if(video.category == null){
      param["type"] = 0;
    }else{
      if(video.adtype == 0){
        param["type"] = 1;
      }else{
        param["type"] = 2;
      }
    }
    String pingbackKey = "ShortVideoPlay";
    Map dataMap = Map();
    dataMap["key"] = pingbackKey;
    dataMap["param"] = param;
    SgOperation.statistics(SgOperation.STATISTICS_IMMEDIATELY_TYPE, dataMap);

  }

  static void sendAdShowPingback(VideoItem videoItem){
    //pingback

    String type;
    if (videoItem.category != null && videoItem.adtype == 1){
      type = "download"; //下载广告
    }else if(videoItem.category != null && videoItem.adtype == 0){
      type = "h5";//普通广告
    }else {
      return;
    }
    String pingbackKey = "ShortVideoAdShow";
    Map pingbackParam = new Map();
    pingbackParam["name"] = Constant.CHANNEL ?? "";
    pingbackParam["adid"] = videoItem.newsid ?? ""; //广告id需要根据数据来定
    pingbackParam["title"] = videoItem.title ?? "";
    pingbackParam["url"] = videoItem.video_url ?? "";
    pingbackParam["type"] = type;
    if (videoItem.category != null && videoItem.adtype == 1){
      pingbackParam["downloadurl"] = videoItem.url ?? "";
      pingbackParam["h5url"] = ""; //待修改
    }else {
      pingbackParam["h5url"] = videoItem.url ?? "";
      pingbackParam["downloadurl"] = "";
    }
    Map dataMap = new Map();
    dataMap["key"] = pingbackKey;
    dataMap["param"] = pingbackParam;
    ILog.lg.i("广告show pingback参数:$pingbackParam");
    SgOperation.statistics(SgOperation.STATISTICS_IMMEDIATELY_TYPE, dataMap);

    ILog.lg.i("开始广告展现的回传");
    //广告展现回传
    Map trackaram = new Map();
    trackaram["url"] = videoItem.url ?? "";
    List<dynamic> tackUrls = videoItem.trackUrls??List<dynamic>();
    trackaram["trackUrls"] = tackUrls;
    ILog.lg.i("广告回传参数:$trackaram");
    SgOperation.showAdSendTrack(trackaram);
  }

  static String getCurrentTime(){

    String time;
    var now = new DateTime.now();
    var formatter = new DateFormat('yyyy-MM-dd HH:mm:ss');
    time = formatter.format(now);
    return time;
  }

}