import 'dart:ui' as prefix0;

import 'package:flutter/material.dart';
import 'dart:ui';

import 'package:flutter/material.dart' as prefix1;

/// 该类是用来绘制广告的视频底部的广告描述文本
class MultiRowAdText extends CustomPainter {
  String text;//文本
  double width;//宽度
  int maxLines;//最大行数限制
  TextStyle textStyle;//样式
  double height;
  MultiRowAdText(
      {
        @required this.text,
        @required this.textStyle,
        @required this.width,
        @required this.maxLines,
        this.height
      });
  @override
  void paint(Canvas canvas, Size size) {
    var paint = new Paint();
    paint.color = textStyle.color;

    if(this.text == null || this.text.length < 1){
      canvas.drawRRect(
          RRect.fromLTRBXY(3.5, 3, 30.5, 18, 3.0, 3.0),
          Paint()..color = Color(0x5F000000)..strokeWidth = 1.0..style = PaintingStyle.fill
      );
      TextSpan adSpan = new TextSpan(
        style: TextStyle(
          color: Colors.white,
          fontSize: 10,
          letterSpacing: 1,
          wordSpacing: 1,
          backgroundColor: Colors.transparent,
        ),
        text: ' 广告 ',
      );
      TextPainter adTp = new TextPainter(
        text: adSpan,
        textAlign: TextAlign.center,
        textDirection: TextDirection.ltr,
      );
      adTp.layout();
      Offset offsetTemp= Offset(0, 3);
      adTp.paint(canvas, offsetTemp);
      return;
    }


    double offsetX = 0;
    double offsetY = 0;
    bool newLine = false;
    bool finish = false;
//    print('绘制size ='+size.toString());

//    maxWidth = this.width;
//    maxHeight = this.height;
    double adLabelWidth = findeTextLabelWidth("广告", this.textStyle)+2;
    double ellipsisAndAdWidth = findeTextLabelWidth("...广告", this.textStyle);
    int lineNumber = 1;

//    print('广告宽度:' + adLabelWidth.toString());
//    print('省略号+广告宽度:' + ellipsisAndAdWidth.toString());

    int adTextLineNumber = findTextLabelLineNumber(this.text, this.textStyle,this.width);
//    print(adTextLineNumber.toString()+"行数");
//    int ellipsisAdTextNumber =0; findTextLabelLineNumber(this.text+"... 广告 ", this.textStyle,this.width);
//    print("纯广告行数="+adTextLineNumber.toString()+" 省略号广告行数："+ellipsisAdTextNumber.toString());
    int totalWords = 0;//总共字符数目
    text.runes.forEach((str) {
      totalWords = totalWords + 1;
    });
    int curWords = 0;//当前已绘字符数
    text.runes.forEach((rune){
      bool stop = false;
      int cur = text.length;
      String str = new String.fromCharCode(rune);
      TextSpan span = new TextSpan(style: textStyle, text: str);
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr
      );
      tp.layout();
      Offset offsetTemp;
      if(adTextLineNumber <= this.maxLines) {//行数可以完全展示广告
        curWords = curWords + 1;
        if(offsetX + tp.width > this.width) {
          newLine = true;
        }else {
          newLine = false;
        }
        if(newLine) {
          offsetX = 0;
          lineNumber = lineNumber + 1;
          var deFaultH = getHOfCWord()*(lineNumber - 1);
          if (tp.height < getHOfCWord()) {
            offsetY = (getHOfCWord() - tp.height) + deFaultH;
          } else{
            offsetY = deFaultH;
          }
          newLine = false;
          offsetTemp = new Offset(offsetX, offsetY);
          offsetX = tp.width;
        }else {
          //第一行，绘制的字的y坐标为0，第二行，绘制的字的y坐标为一个字的高度
          var deFaultH = getHOfCWord()*(lineNumber - 1);
          if (tp.height < getHOfCWord()) {
              offsetY = (getHOfCWord() - tp.height)+deFaultH;
          } else {
              offsetY = deFaultH;
          }

          offsetTemp = new Offset(offsetX, offsetY);
          offsetX = offsetX + tp.width;
        }
        if(lineNumber > this.maxLines || curWords >= totalWords) {
          stop = true;
        }
//        print('当前文字数目='+curWords.toString()+';总字数='+totalWords.toString()+'当前字符='+str);
        if(!stop){//未结束继续绘制
          tp.paint(canvas, offsetTemp);
        }else {
          if(finish == false) {
            double oldOffsetX =  offsetTemp.dx;
            if(offsetX + adLabelWidth > this.width) {//未超越宽度
              offsetX = 0;
              offsetY += tp.height;
              offsetTemp = new Offset(offsetX, offsetY);
              tp.paint(canvas, offsetTemp);
              offsetX = tp.width;
            }else {
              tp.paint(canvas, offsetTemp);
              offsetTemp = new Offset(oldOffsetX, offsetY);
            }
            double left = offsetX;//-14 > 0 ? offsetX-14 : 0;
            double right = left + 32;
            canvas.drawRRect(
                RRect.fromLTRBXY(left+4, offsetY+2, right+2, offsetY+18, 3.0, 3.0),
                Paint()..color = Color(0x5F000000)..strokeWidth = 1.0..style = PaintingStyle.fill
            );
            //绘制广告标签
            TextSpan adSpan = new TextSpan(
              style: TextStyle(
                color: Colors.white,
                fontSize: 10,
                letterSpacing: 1,
                wordSpacing: 1,
                backgroundColor: Colors.transparent,
              ),
              text: ' 广告 ',
              children:<TextSpan>[
                new TextSpan(text: "",
                  style: TextStyle(
                    color: Colors.white,
                  ),
                ),
              ],
            );
            TextPainter adTp = new TextPainter(
              text: adSpan,
              textAlign: TextAlign.center,
              textDirection: TextDirection.ltr,
            );
            adTp.layout();
            double charHeight = adTp.height;
            double marginTop = (16 - charHeight) * 1.0 / 2;
            offsetTemp= Offset(offsetX + 1.5, offsetY + marginTop + 2);
            adTp.paint(canvas, offsetTemp);
            finish = true;
            this.height = offsetY+2+adTp.height;
//            print("文本高度="+this.height.toString());
//            RenderComparison.layout;

//            BoxConstraints;
            //结束
          }
          return;
        }
      }else {//文字数目超过行数的显示
        if(offsetX + tp.width > this.width) {
          newLine = true;
        }else {
          newLine = false;
        }
        if(newLine) {
          offsetX = 0;
          lineNumber = lineNumber + 1;
          var deFaultH = getHOfCWord()*(lineNumber - 1);
          if (tp.height < getHOfCWord()) {
            offsetY = (getHOfCWord() - tp.height) + deFaultH;
          } else{
            offsetY = deFaultH;
          }
          newLine = false;
          offsetTemp = new Offset(offsetX, offsetY);
          offsetX = tp.width;
        }else {
          //第一行，绘制的字的y坐标为0，第二行，绘制的字的y坐标为一个字的高度
          var deFaultH = getHOfCWord()*(lineNumber - 1);
          if (tp.height < getHOfCWord()) {
            offsetY = (getHOfCWord() - tp.height)+deFaultH;
          } else {
            offsetY = deFaultH;
          }
          offsetTemp = new Offset(offsetX, offsetY);
          offsetX = offsetX + tp.width;
        }
        if(lineNumber >= this.maxLines) {
          if(offsetX + ellipsisAndAdWidth > this.width  && !finish) {
            //达到最大
//            print('11当前行数：'+ lineNumber.toString());
            stop = true;
            //当前字符不能继续绘制,需要绘制'...广告'
            //绘制...
            TextSpan ellipsisSpan = new TextSpan(
              style:this.textStyle,
//               style: TextStyle(
//                 color: Colors.white,
//                 fontSize: 15,
//                 letterSpacing: 1,
//                 wordSpacing: 1,
//                 backgroundColor: Colors.black,
//               ),
              text:'...',
            );
            TextPainter ellipsisTp = new TextPainter(
              text: ellipsisSpan,
              textAlign: TextAlign.center,
              textDirection: TextDirection.ltr,
            );
            ellipsisTp.layout();
            ellipsisTp.paint(canvas, offsetTemp);
//             print("。。。位置："+offsetTemp.toString()+'ellipsisTp.width='+ellipsisTp.width.toString());
            offsetX = offsetTemp.dx + ellipsisTp.width;

            //绘制广告标签
            double left = offsetX;//-14 > 0 ? offsetX-14 : 0;
            double right = left + 32;
            canvas.drawRRect(
                RRect.fromLTRBXY(left+2, offsetY+2, right, offsetY+18, 3.0, 3.0),
                Paint()..color = Color(0x5F000000)..strokeWidth = 1.0..style = PaintingStyle.fill
            );
            TextSpan adSpan = new TextSpan(
              style: TextStyle(
                color: Colors.white,
                fontSize: 10,
                letterSpacing: 1,
                wordSpacing: 1,
                backgroundColor: Colors.transparent,
              ),
              text: ' 广告 ',
            );
            TextPainter adTp = new TextPainter(
              text: adSpan,
              textAlign: TextAlign.center,
              textDirection: TextDirection.ltr,
            );
            adTp.layout();
            double charHeight = adTp.height;
            double marginTop = (16 - charHeight) * 1.0 / 2;
            offsetTemp= Offset(offsetX - 0.5, offsetY + marginTop + 2);
            adTp.paint(canvas, offsetTemp);
            finish = true;//结束
            this.height = offsetY+2+ellipsisTp.height;
//            print("文本高度="+this.height.toString());
            return;
          }else {
            if(finish) {
              return;
            }
            tp.paint(canvas, offsetTemp);
          }
        }else {//未达到最大行数继续绘制
          tp.paint(canvas, offsetTemp);
        }
      }
    });
  }

  //计算一个汉字的高度，解决部分手机数字、字母与汉字绘制高度不同的问题
  double getHOfCWord() {
    String chineseWord = "字";
    TextSpan span = new TextSpan(style: TextStyle(
      fontSize: 15,
      letterSpacing: 0.5,
      wordSpacing: 1,
    ), text: chineseWord);
    TextPainter tp = new TextPainter(
        text: span,
        textAlign: TextAlign.center,
        textDirection: TextDirection.ltr
    );
    tp.layout();
    return tp.height;
  }

  double findMaxWidth(String text, TextStyle style) {
    double maxWidth = 0;

    text.runes.forEach((rune) {
      String str = new String.fromCharCode(rune);
      TextSpan span = new TextSpan(style: style, text: str);
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr);
      tp.layout();
      maxWidth = max(maxWidth, tp.width);
    });

    return maxWidth;
  }
//查询文本宽度
  double findeTextLabelWidth(String text, TextStyle style) {
    double adWidth = 0;
    text.runes.forEach((rune){
      String str = new String.fromCharCode(rune);
      TextSpan span = new TextSpan(style: style, text: str);
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr
      );
      tp.layout();
      adWidth = adWidth + tp.width;
    });
    return adWidth;
  }

  //查询文本的行数
  static int findTextLabelLineNumber(String text, TextStyle style ,double width) {
    double offsetX = 0;//坐标X
    double offsetY = 0;//坐标Y
    bool newLine = false;
    int lineNumber = 1;//行数统计

    text.runes.forEach((rune){
      String str = new String.fromCharCode(rune);
      TextSpan span = new TextSpan(style: style, text: str);
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr
      );
      tp.layout();
//      print("字符="+str);
      if(offsetX + tp.width > width) {
        newLine = true;
      }else {
        newLine = false;
      }
      if(newLine) {
        offsetX = 0;
        lineNumber = lineNumber + 1;
        offsetY += tp.height;
        newLine = false;
        offsetX = tp.width;
      }else {
        offsetX = offsetX + tp.width;
      }
//      print('当前行数='+lineNumber.toString()+"tpwidth"+tp.width.toString()+'offsetx='+offsetX.toString()+'宽'+width.toString());
//      print("当前文字："+str+"高度="+tp.height.toString());
    });
    //33为广告的宽度
    if(offsetX + 33 > width) {
      lineNumber = lineNumber + 1;
    };
//    print('最终行数='+lineNumber.toString());
    return lineNumber;
  }
  //查询文本的行数
  static double findTextLabelHeight(String text, TextStyle style ,double width,int maxLines) {
    double offsetX = 0;//坐标X
    double offsetY = 0;//坐标Y
    bool newLine = false;
    int lineNumber = 1;//行数统计
    double textHeight = 0;

    text.runes.forEach((rune){
      String str = new String.fromCharCode(rune);
      TextSpan span = new TextSpan(style: style, text: str);
      TextPainter tp = new TextPainter(
          text: span,
          textAlign: TextAlign.center,
          textDirection: TextDirection.ltr
      );
      tp.layout();
//      print("字符="+str);
      if(offsetX + tp.width > width) {
        newLine = true;
      }else {
        newLine = false;
      }
      if(newLine) {
        offsetX = 0;
        lineNumber = lineNumber + 1;
        offsetY += tp.height;
        newLine = false;
        offsetX = tp.width;
      }else {
        offsetX = offsetX + tp.width;
      }
//      print('当前行数='+lineNumber.toString()+"tpwidth"+tp.width.toString()+'offsetx='+offsetX.toString()+'宽'+width.toString());
    });
    //33为广告的宽度
    if(offsetX + 33 > width) {
      lineNumber = lineNumber + 1;
    };
    TextSpan span = new TextSpan(style: style, text: "中");
    TextPainter tp = new TextPainter(
        text: span,
        textAlign: TextAlign.center,
        textDirection: TextDirection.ltr
    );
    tp.layout();
    maxLines = maxLines <= lineNumber? maxLines:lineNumber;
//    print('中文高度='+tp.height.toString());
    textHeight = maxLines.toDouble() * tp.height;
//    print('最终行数='+maxLines.toString()+"；文本行数"+lineNumber.toString());
    return textHeight;
  }

  @override
  bool shouldRepaint(MultiRowAdText oldDelegate) {//是否重绘
    return oldDelegate.text != text ||
        oldDelegate.textStyle != textStyle ||
        oldDelegate.width != width;
  }

  double max(double a, double b) {
    if (a > b) {
      return a;
    } else {
      return b;
    }
  }
}


//自定义带广告的文本widget
class TextAdWidget extends StatelessWidget {
  String text;
  TextStyle style;
  double width;
  int maxLines;
  TextAdWidget(
      {
        @required this.text,
        @required this.style,
        @required this.width,
        @required this.maxLines,

      });
  double height = 0;
  @override
  Widget build(BuildContext context) {
    double height = MultiRowAdText.findTextLabelHeight(this.text, this.style, this.width,this.maxLines);
//    print('文本框高度height='+height.toString());
    return CustomPaint(
      size: Size(width, height),
      painter: MultiRowAdText(
          textStyle: this.style,
          text: this.text,
          maxLines: this.maxLines,
          width: width
      ),
    );
  }
}

class Adapt {
  static MediaQueryData mediaQuery = MediaQueryData.fromWindow(window);
  static double _width = mediaQuery.size.width;
  static double _height = mediaQuery.size.height;
  static double _topbarH = mediaQuery.padding.top;
  static double _botbarH = mediaQuery.padding.bottom;
  static double _pixelRatio = mediaQuery.devicePixelRatio;
  static var _ratio;
  static init(int number){
    int uiwidth = number is int ? number : 750;
    _ratio = _width / uiwidth;
  }
  static px(number){
    if(!(_ratio is double || _ratio is int)){Adapt.init(750);}
    return number * _ratio;
  }
  static onepx(){
    return 1/_pixelRatio;
  }
  static screenW(){
    return _width;
  }
  static screenH(){
    return _height;
  }
  static padTopH(){
    return _topbarH;
  }
  static padBotH(){
    return _botbarH;
  }
}