import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

typedef Future<bool> ScaffoldBackHandler(BuildContext context);

abstract class BaseStateLessNaviScreen extends StatelessWidget {
  BaseStateLessNaviScreen({Key key}) : super(key: key);

  static GlobalKey<ScaffoldState> currentNaviScreenKey = null;


  static Widget buildScaffold(BuildContext context, String titleStr,
      Widget bodyWidget, ScaffoldBackHandler callback) {
    GlobalKey<ScaffoldState> globalKey =  new GlobalKey<ScaffoldState>();
//    currentNaviScreenKey =  globalKey;
    return WillPopScope(
      child: Scaffold(
//          key: currentNaviScreenKey,
          resizeToAvoidBottomInset : false,
          resizeToAvoidBottomPadding: false,
          appBar: AppBar(
            title: Text(titleStr),
          ),
          body: bodyWidget),
      onWillPop: () {
        if (callback != null) {
          return callback(context);
        } else {
          return Future(() => true);
        }
      },
    );
  }

  @override
  Widget build(BuildContext context) {
    return buildScaffold(context, title(context), body(context), onBackPressed);
  }

  String title(BuildContext context);

  Widget body(BuildContext context);

  /// true , 表示直接退出
  /// false, 表示不退出
  Future<bool> onBackPressed(BuildContext context) {
    return Future(() => true);
  }
}
