import 'package:flutter/material.dart';
import 'package:short_video/base/i_log.dart';

enum ImageButtonStatus {
  normal,
  highlighted,
  selected,
}

class ImageButtonWidget extends StatefulWidget {
//  final Widget child;

  Function onTap;
  String normalImage;
  String selectImage;
  String highlightedImage;
  ImageButtonStatus status = ImageButtonStatus.normal;
  double width;
  double height;
  double imageWidth;
  double imageheight;

  ImageButtonWidget({Key key, this.normalImage,this.highlightedImage,this.selectImage,this.imageWidth,this.imageheight, @required this.onTap,this.status,this.width,this.height}) : super(key: key);

//获取对应状态的图片
  String getStatusImage() {
    if (this.status == ImageButtonStatus.normal) {
      return this.normalImage;
    }else if(this.status == ImageButtonStatus.highlighted) {
      return this.highlightedImage;
    }else if(this.status == ImageButtonStatus.selected) {
      return this.selectImage;
    } else {
      ILog.lg.i("图片状态为"+null.toString());
      return null.toString();
    }
  }

//  String getHight

  @override
  ImageButtonWidgetState createState() {
    return new ImageButtonWidgetState();
  }
}

class ImageButtonWidgetState extends State<ImageButtonWidget> with SingleTickerProviderStateMixin {
  bool isPressed = false;
  @override
  void initState() {
    super.initState();
    isPressed = false;
  }

  @override
  void dispose() {

    super.dispose();
  }


  @override
  Widget build(BuildContext context) {
//    print("图片按钮widget点击事件="+widget.onTap.toString());
//  widget.onTap;
    return GestureDetector(
      child:Container(
        width: widget.width != null? widget.width:null,
        height: widget.height != null? widget.height:null,
        color: Colors.transparent,
        child: Center(
          child: Container(
            width:widget.imageWidth != null? widget.imageWidth:widget.width,
            height:widget.imageheight != null? widget.imageheight:widget.height,
            foregroundDecoration: BoxDecoration(
              color:Colors.transparent ,
              image: DecorationImage(
                image: this.isPressed == true ? Image.asset(widget.highlightedImage).image : Image.asset(widget.getStatusImage()).image,
              ),
            ),
          ),
        ),
//        Container(
//          width:widget.imageSize != null? widget.imageSize:widget.width,
//          height:widget.imageSize != null? widget.imageSize:widget.width,
//          foregroundDecoration: BoxDecoration(
//            color:Colors.transparent ,
//            image: DecorationImage(
//              image: this.isPressed == true ? Image.asset(widget.highlightedImage).image : Image.asset(widget.getStatusImage()).image,
//            ),
//          ),
//        ),
      ),

      onTap: (){
        widget.onTap();
       },
      onTapDown: (d){
//        this.isPressed = true;
        setState(() {
//          print("按下态");
          this.isPressed = true;
        });
      },
      onPanDown: (details){

        setState(() {
//          print("按下态");
          this.isPressed = true;
        });
      },
      onTapUp:(d){
//        print("抬起");
        setState(() {
          this.isPressed = false;
        });

      },
      onPanCancel: (){
//        this.isPressed = false;
        setState(() {
//          print("取消");
          this.isPressed = false;
        });
      },
      onTapCancel: () =>() {
//        this.isPressed = false;
        setState(() {
//          print("取消");
//          this.isPressed = false;
          this.isPressed = false;
        });
      },
      onVerticalDragEnd:(d) {
//        this.isPressed = false;
        setState(() {
          print("取消");
          this.isPressed = false;
        });
        },
      onHorizontalDragEnd:(d){
//        this.isPressed = false;
        setState(() {
          print("取消");
          this.isPressed = false;
        });
        },
    );
  }
}
