import 'package:flutter/material.dart';
import 'package:short_video/bean/video_item.dart';
import 'package:short_video/model_item.dart';
import 'package:short_video/platform/sg_operation.dart';
import 'package:short_video/util/constant.dart';
import 'package:short_video/widget/image_button_widget.dart';

class ShareButton extends StatelessWidget {
  final VideoItem videoItem;

  const ShareButton(this.videoItem);

  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisSize: MainAxisSize.min,
      crossAxisAlignment: CrossAxisAlignment.center,
      children: [
        ImageButtonWidget(
          normalImage: "assets/images/video_toolbar_share_normal.png",
          highlightedImage: "assets/images/video_toolbar_share_highlighted.png",
          width: 40,
          height: 40,
          status: ImageButtonStatus.normal,
          onTap: () {
            clickShareVideoButtonWidget(context);
          },
        ),
        SizedBox(
          height: 20.0,
          child: Container(
            margin: EdgeInsets.only(left: 0, top: 0, bottom: 1),
            color: Colors.transparent,
            child: Text(
              '分享',
              textAlign: TextAlign.center,
              style: TextStyle(fontSize: 14, color: Colors.white),
            ),
          ),
        ),
      ],
    );
  }

//分享事件
  void clickShareVideoButtonWidget(BuildContext context) {
    VideoItemModel.of(context).applyPause();
    if(videoItem.url == null || videoItem.url.length < 1) {
      //url不存在不允许分享
      return;
    }
    Map param = new Map();
    param["url"] = videoItem.url ?? "";
    String imgUrl = "";
    if (videoItem.picurls != null && videoItem.picurls.length > 0) {
      imgUrl = videoItem.picurls[0];
    }
    param["imgUrl"] = imgUrl;
    param["title"] = videoItem.title ?? "";
    param["key"] = videoItem.key ?? "";
    param["url"] = videoItem.url ?? "";
    SgOperation.shareVideo(param);

    //pingback
    String pingbackKey = "ShortVideoShareClick";
    Map pingbackParam = new Map();
    pingbackParam["name"] = Constant.CHANNEL ?? "";
    pingbackParam["url"] = videoItem.url ?? "";
    pingbackParam["title"] = videoItem.title ?? "";
    pingbackParam["newsid"] = videoItem.newsid ?? "";
    Map dataMap = new Map();
    dataMap["key"] = pingbackKey;
    dataMap["param"] = pingbackParam;
    SgOperation.statistics(SgOperation.STATISTICS_IMMEDIATELY_TYPE, dataMap);
  }
}
