import 'package:flutter/material.dart';

/// 用户引导提示浮层widget
class UserGuidWidget extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return _UserGuidWidgetState();
  }
}

class _UserGuidWidgetState extends State<UserGuidWidget>
    with SingleTickerProviderStateMixin {
  AnimationController animationController;

  @override
  void initState() {
    super.initState();
    animationController = AnimationController(
        duration: Duration(milliseconds: 1500), vsync: this);
    animationController.addListener(() {
      if (mounted) {
        setState(() {});
      }
    });
//    animationController.forward(from: 0.0);
    animationController.repeat();
  }

  @override
  void deactivate() {
    animationController.stop();
    super.deactivate();
  }

  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      crossAxisAlignment: CrossAxisAlignment.center,
      children: <Widget>[
        Stack(
          alignment: Alignment.topCenter,
          children: <Widget>[
            Image(
                width: 20,
                height: 220,
                image:
                    Image.asset("./assets/images/video_hint_scratch_path.png")
                        .image),
            Transform.translate(
              offset: Offset(0, 220 * (1 - animationController.value)),
              child: Padding(
                padding: EdgeInsets.only(left: 60),
                child: Image(
                    width: 79,
                    height: 67,
                    image: Image.asset(
                            "./assets/images/video_hint_microcheiria.png")
                        .image),
              ),
            ),
          ],
        ),
        SizedBox(
          height: 10,
        ),
        Container(
          color: Colors.transparent,
          margin: EdgeInsets.only(top: 30),
          width: 160,
          height: 30,
          child: Image(
              image: Image.asset("./assets/images/video_hint_show_more.png")
                  .image),
        )
      ],
    );
  }
}
